// InpoutTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#include "conio.h"

#define CLK 0
#define LOAD 2  
#define DATA 1
/* ----Prototypes of Inp and Outp--- */

short _stdcall Inp32(short PortAddress);
void _stdcall Out32(short PortAddress, short data);

/*--------------------------------*/
void delay(int d)
{
	for(long i=0;i<20*d;i++)
		for(long h=0;h<100;h++);
}

unsigned char b=0;

void output_low(char bit)
{
	char t=1<<bit;
	t=~t;
	b= b&t;
	Out32(0x378,b);
	delay(10);
}
void output_high(char bit)
{
	char t=1<<bit;
	b= b|t;
	Out32(0x378,b);
	delay(10);
}
int bit_test(char byte, char bit)
{
	return ((byte & (1<<bit) ) == 1 <<bit);
}

void max7219(char adresse,char wert)
{
 char x;
 output_low(LOAD);

 for (x=0;x<4;x++)
 {
  output_low(DATA);
  output_high(CLK);
  output_low(CLK);
 }
 for (x=4;x>0;x--)
 {
  if (bit_test(adresse,x-1)) output_high(DATA);
  else output_low(DATA);
  output_high(CLK);
  output_low(CLK);
 }

 for (x=8;x>0;x--)
 {
  if (bit_test(wert,x-1)) output_high(DATA);
  else output_low(DATA);
  output_high(CLK);
  output_low(CLK);
 }

}

void max7219_init()
{
 max7219(0x0b, 0x07);
 max7219(0x0b, 0x07); 
 output_high(LOAD);
 max7219(0x0c, 0x01); 
 max7219(0x0c, 0x01); 
 output_high(LOAD);
 max7219(0x09,0x00); 
 max7219(0x09,0x00); 
 output_high(LOAD);
 
}


void main()
{
	output_high(LOAD); 
	
	output_low(CLK);
	max7219_init();
	max7219(1,0);
	max7219(1,0);
	output_high(LOAD); 
	getch();
	unsigned char r=0;
	int val = 256+512;
	while(1)
	{
		
		char rg = val & 0xf;
		char br = (val & 0xf0) >> 4;
		char ron = (val & 0x100)?1:0;
		char gon = (val & 0x200)?1:0;
		char bon = (val & 0x400)?1:0;

		max7219(0x0a,rg/(ron?3:1)); // RG Brightness
		max7219(0x0a,br); // Blue Brightness
		output_high(LOAD);
		max7219(r+1,2*ron+gon+4*ron+8*gon);
		max7219(r+1,3*bon+12*bon);
		r++;
		r%=8;
		if(r==0)
		{
			val++;
			if(bon == 0) val+=0xff;
			if(ron == 0 && gon==0) val+=0xf;
			
			printf("\n%d\nR: %*c\nB: %*c \n%3d %3d %3d",val,rg,'#',br,'#',ron,gon,bon);

		}
		output_high(LOAD);
		delay(100);
	}
}
//vars : RG Brightness, B Brightness, R G B on? 7FF
/* call 1 
led 1 
1: GREEN
2: RED
3: GR
led 2
4: RED
8:GREEN
12:GR

  call 2
3 : Blue 1
12: blue 2
*/
